%% ܶݼͱԵȫ
% Step 2, after S1_RemoveNoise.mڻCRF㷨ݼͱ֮
% 20210922
% ݼ ÿݼֵ[0,1],ֵ=0ʱΪȫ屻
% 1.˿Ϣ2.죻
% Input: CRFȥcount˸ı

clear
clc
close all

% ·
LoadPath = '../result/TypicalData/'; % load 
SavePath = strcat('../result/Evaluation/MainTypical/');

LoadDataPath = '../data/Regression/'; % FNC Matrix
DataName = {'FBIRN', 'MPRC', 'BSNIP','COBRE'};

LoadMotPath = 'D:\Data\FNC\'; % Demographic
DemoDataName = {'FBIRN-137SZ_144HC', 'PK-150SZ-238HC', 'BSNIP-182SZ_237HC','COBRE-68SZ_89HC'}; % ˿Ϣͳ

ThsInd = cellstr(num2str(roundn([0:0.1:1.0],-2)'));
ThsInd(1) = {'0'};ThsInd(length(ThsInd)) = {'1'};

Col = 1379;
PvalPara = 0.01/(Col-1); % FNC_Pval ֵ
TvalClim = [-12 12]; % Tval Colorbar Χ

%% # Evaluation 
%% 1.˿Ϣ Demographic information
% ʼڴı
Demog = cell(length(DataName)+1,2);
Demog(1,:) = [{'Dataset'} {'Demog'}];
Demog(2:end,1) = DataName'; % 4ݼӦ˿Ϣֵȡ[0,1]
DemogShow = Demog;
for D = 1:length(DataName)    
    load(strcat(LoadPath,DataName{D},'.mat'),'count')
    load(strcat(LoadDataPath,DataName{D},'.mat'));
    data = eval(DataName{D});
    [SampNum,Col] = size(data); PvalPara = 0.01/(Col-1); % FNC_Pval ֵ
    OriLabel = data(:,Col);
    OriIDG1 = find(OriLabel==1);
    OriIDG2 = find(OriLabel==2);
    clear FBIRN MPRC BSNIP COBRE

    Population = cell(length(ThsInd)+2,4);
    Population(:,1) = [{' '}; {'Ori'};ThsInd];
    Population(1,2:4) = [{'HC'} {'Disorder'} {'Popu-Pval'}];
    %  ['SubID'  'Age' 'Gender' 'Trans' 'Rotat']
    PopulationShow = cell(length(ThsInd)*3+1,12);
    PopulationShow(1,:) = [ {' '} {' '} 'OSubID'  'OAge' 'OGender' 'OTrans' 'ORotat' 'TSubID'  'TAge' 'TGender' 'TTrans' 'TRotat'];
    PopulationShow(2:end,1:2) = [reshape(repmat(ThsInd', 3, 1),length(ThsInd)*3,1) repmat([{'HC'};{'SZ'};{'Pval'}], length(ThsInd), 1)];

    % 1.1 ˿Ϣ Demographic information - Original subjects
    load(strcat('D:\Data\FNC\Process\',DataName{D},'.mat'),'DisorderAge','DisorderGender','HealthyAge','HealthyGender')
    Age = [HealthyAge;DisorderAge];
    Gender = [HealthyGender;DisorderGender];
    StInd = [2 2:size(PopulationShow,1)]; % ֵͬ

    [Population,PopulationShow] = PopulStat(Population,PopulationShow,StInd,OriIDG1,OriIDG2,OriIDG1,...
        HealthyAge,DisorderAge,HealthyGender,DisorderGender,LoadMotPath,DemoDataName{D},'Ori');

    % 1.2 ˿Ϣ Demographic information - Typical subjectsֵµĽ
    Ths = 0;
    for T = 1:length(ThsInd)
        ind = find(strcmp(num2str(Ths),Population(:,1)));
        TypIDG1 = find(count(:,4)>=Ths & OriLabel==1);
        TypIDG2 = find(count(:,4)>=Ths & OriLabel==2);

        StInd = [find(strcmp(num2str(Ths),Population(:,1))) ...
            find(strcmp(num2str(Ths),PopulationShow(:,1)))'];
        [Population,PopulationShow] = PopulStat(Population,PopulationShow,StInd,TypIDG1,TypIDG2,OriIDG1,...
            Age(TypIDG1),Age(TypIDG2),Gender(TypIDG1),Gender(TypIDG2),LoadMotPath,DemoDataName{D},'Typ');

        Ths = Ths+0.1;
        clear TypIDG1 TypIDG2
    end
    Demog{D+1,2} = Population;
    DemogShow{D+1,2} = PopulationShow;
    clear Age Gender
    save(strcat(SavePath,'Demographic.mat'),'Demog','DemogShow');
    clear data count OriLabel OriIDG1 OriIDG2 Population PopulationShow...
       HealthyAge DisorderAge HealthyGender DisorderGender
end
clear DemoDataName Demog DemogShow

%% 2. Group difference
FNC_Pval = cell(length(DataName)+1,2);
FNC_Pval(1,:) = [{'Dataset'} {'GroupDiff'}];
FNC_Pval(2:end,1) = DataName'; % 4ݼӦ˿Ϣֵȡ[0,1]
load('../data/domain_ICN.mat');load('../data/MOD_NAMES.mat')
clear DataNameStr DataNameStr GroupNameStr

for D = 1:length(DataName)    
    load(strcat(LoadPath,DataName{D},'.mat'),'count')
    load(strcat(LoadDataPath,DataName{D},'.mat'));
    data = eval(DataName{D});
    [SampNum,Col] = size(data); PvalPara = 0.01/(Col-1); % FNC_Pval ֵ
    OriLabel = data(:,Col);
    OriIDG1 = find(OriLabel==1);
    OriIDG2 = find(OriLabel==2);
    clear FBIRN MPRC BSNIP COBRE
    
    GroupDiff = cell(length(ThsInd)+2,6);
    GroupDiff(:,1) = [{' '}; {'Ori'};ThsInd];
    GroupDiff(1,2:6) = [{'FNC-Pval'}  {'FNC-Tval'} {'PearsonCorr'} {'KendallCorr'} {'SpearmanCorr'} ];
 
    % 2.1  Group difference - Original subjects
    OriG1 = data(OriIDG1,1:Col-1);
    OriG2 = data(OriIDG2,1:Col-1);
    OriAttr = [OriG1;OriG2];
    [~,OriPval,~,stats] = ttest2(OriG1,OriG2); Fea = CumFea(OriPval,PvalPara);
    OriTval = stats.tstat; OriTval(setdiff(1:length(OriPval),Fea))=0;
    [OriCorrPear] = Correlation(OriG1,OriG2,'Pearson');
    [OriCorrKend] = Correlation(OriG1,OriG2,'Kendall');
    [OriCorrSpear] = Correlation(OriG1,OriG2,'Spearman');   
    GroupDiff(2,2:6) = [{OriPval} {stats.tstat} {OriCorrPear} {OriCorrKend} {OriCorrSpear}];
   
    clear OriG1 OriG2 OriIDG1 OriIDG2 OriAttr Fea OriPval OriTval stats...
         OriCorrKend OriCorrSpear
   
    % 2.2  Group difference - Typical subjectsֵµĽ
    Ths = 0;
  
    for T = 1:length(ThsInd)
        ind = find(strcmp(num2str(Ths),GroupDiff(:,1)));
        TypG1 = data(find(count(:,4)>=Ths & OriLabel==1),1:Col-1);
        TypG2 = data(find(count(:,4)>=Ths & OriLabel==2),1:Col-1);
        TypAttr = [TypG1;TypG2];
        TypLabel = [ones(size(TypG1,1),1);ones(size(TypG2,1),1)+1];
        [~,TypPval,~,stats] = ttest2(TypG1,TypG2); TypFea = CumFea(TypPval,PvalPara);
        TypTval = stats.tstat; TypTval(setdiff(1:length(TypPval),TypFea))=0;
        [TypCorrPear] = Correlation(TypG1,TypG2,'Pearson');
        [TypCorrKend] = Correlation(TypG1,TypG2,'Kendall');
        [TypCorrSpear] = Correlation(TypG1,TypG2,'Spearman');
        GroupDiff(ind,2:6) = [{TypPval} {stats.tstat} {TypCorrPear} {TypCorrKend} {TypCorrSpear}];                
        
        Ths = Ths+0.1;

        clear TypG1 TypG2 TypAttr TypFea TypLabel TypPval TypTval stats...
            TypCorrPear TypCorrKend TypCorrSpear
        FNC_Pval{D+1,2} = GroupDiff;
        save(strcat(SavePath,'GroupDifference.mat'),'FNC_Pval');
    end
    
    clear data count OriIDG1 OriIDG2 OriLabel TypAttr TypLabel...
        TypFea TypPval TypTval TypCorrPear TypCorrKend TypCorrSpear ClustIndex
end
clear GroupDiff FNC_Pval ClustEval ClusterShow GroupNameStr DataNameStr MOD_NAMES domain_ICN





%%
% ͳƴ洢LoadMotPathλõDataNameݼ鱻ԵͷϢ
function [Trans,Rotat] = Motat(SampIndHC,SampIndDis,LoadMotPath,DataName)
% Transition / Rotation -HC
flag = 1;
for Sb = 1:(length(dir(strcat(LoadMotPath,DataName,'\HC')))-2)/10
    if ~ismember(Sb,SampIndHC)
        continue
    end
    load(strcat(LoadMotPath,DataName,'\HC\SubG',num2str(Sb),'IndiMotion.mat'))
    IndiMotion = abs(IndiMotion);
    TransHC(flag,1) = mean(mean(IndiMotion(:,1:3)));
    RotatHC(flag,1) = mean(mean(IndiMotion(:,4:6)))*180/pi;
    flag = flag+1;
end

% Transition / Rotation - Disorder
flag = 1;
for Sb = 1:(length(dir(strcat(LoadMotPath,DataName, '\SZ')))-2)/10
    if ~ismember(Sb,SampIndDis)
        continue
    end
    load(strcat(LoadMotPath,DataName, '\SZ\SubG',num2str(Sb),'IndiMotion.mat'))
    IndiMotion = abs(IndiMotion);
    TransDis(flag,1) = mean(mean(IndiMotion(:,1:3)));
    RotatDis(flag,1) = mean(mean(IndiMotion(:,4:6)))*180/pi;
    flag = flag+1;
    
end
Trans = [{TransHC};{TransDis}];
Rotat = [{RotatHC};{RotatDis}];
end


%% 
% ˿Ϣͳƣ䣬Աͷƽƣͷת
function [Population,PopulationShow] = PopulStat(Population,PopulationShow,StInd,IDG1,IDG2,OriG1,...
    AgeG1,AgeG2,GenderG1,GenderG2,LoadMotPath,DataName,flag)
SubNumG1 = {length(IDG1)};
SubNumG2 = length(IDG2);

Age_G1 = {strcat(num2str(roundn(mean(AgeG1),-2)),'(',num2str(roundn(std(AgeG1),-2)),')')};
Age_G2 = {strcat(num2str(roundn(mean(AgeG2),-2)),'(',num2str(roundn(std(AgeG2),-2)),')')};
[~,Page] = ttest2(AgeG1,AgeG2);

GenderNum = [length(find(GenderG1==1)) length(find(GenderG1==2));...
    length(find(GenderG2==1)) length(find(GenderG2==2))];
Gend_G1 = {strcat(num2str(length(find(GenderG1==1))),'/',32,num2str(length(find(GenderG1==2))))};
Gend_G2 = {strcat(num2str(length(find(GenderG2==1))),'/',32,num2str(length(find(GenderG2==2))))};
[~,Pgender] = ChiSquareTest(GenderNum, 0.05) ;

% Trans/RotatбԵTrans/Rotat: [{HC} {SZ}];
% TransSitePval/RotatSitePval:[mean std pval]
[Trans,Rotat] = Motat(IDG1,IDG2-length(OriG1),LoadMotPath,DataName);
Trans_G1 = {strcat(num2str(roundn(mean(Trans{1}),-2)),' (',num2str(roundn(std(Trans{1}),-2)),')')};
Trans_G2 = {strcat(num2str(roundn(mean(Trans{2}),-2)),' (',num2str(roundn(std(Trans{2}),-2)),')')};
Rotat_G1 = {strcat(num2str(roundn(mean(Rotat{1}),-2)),' (',num2str(roundn(std(Rotat{1}),-2)),')')};
Rotat_G2 = {strcat(num2str(roundn(mean(Rotat{2}),-2)),' (',num2str(roundn(std(Rotat{2}),-2)),')')};

[~,Ptrans] = ttest2(Trans{1},Trans{2});
[~,Protat] = ttest2(Rotat{1},Rotat{2});

Population(StInd(1),2:4) = [{[IDG1 AgeG1 GenderG1 Trans{1} Rotat{1}]}...
    {[IDG2 AgeG2 GenderG2 Trans{2} Rotat{2}]}...
    {[ Page Pgender Ptrans Protat]}];
if strcmp('Ori',flag)
    PopulationShow(StInd(2:end),3:7) = repmat([[SubNumG1 Age_G1 Gend_G1 Trans_G1 Rotat_G1];...
        [SubNumG2 Age_G2 Gend_G2 Trans_G2 Rotat_G2];...
        [{' '} {Page} {Pgender} {Ptrans} {Protat} ]],11,1);
else
    PopulationShow(StInd(2:end),8:12) = [[SubNumG1 Age_G1 Gend_G1 Trans_G1 Rotat_G1];...
        [SubNumG2 Age_G2 Gend_G2 Trans_G2 Rotat_G2];...
        [{' '} {Page} {Pgender} {Ptrans} {Protat} ]];
end
clear  IDG2  AgeG1 AgeG2 GenderG1 GenderG2 Trans Rotat...
    Page Pgender Ptrans Prota...
    SubNumG1 SubNumG2 Age_G1 Age_G2 Gend_G1 Gend_G2 Trans_G1 Trans_G2 Rotat_G1 Rotat_G2
end

%%
% Total Correlation coefficient
% Input: Group-1ԾGroup-2Ծ󣻲ͬԷCorrType
% OutputTotalϵϵ/ϵ
function [CorrEval] = Correlation(Attr1,Attr2,CorrType)
WithinCorr1 = corr(Attr1','Type',CorrType);
WithinMeanCorr1 = sum(sum(triu(WithinCorr1)-diag(ones(size(WithinCorr1,1),1))))/((size(WithinCorr1,1)-1)*size(WithinCorr1,1)*0.5);
WithinCorr2 = corr(Attr2','Type',CorrType);
WithinMeanCorr2 = sum(sum(triu(WithinCorr2)-diag(ones(size(WithinCorr2,1),1))))/((size(WithinCorr2,1)-1)*size(WithinCorr2,1)*0.5);
BetweenCorr = mean(mean(corr(Attr1',Attr2','Type',CorrType)));
CorrEval = (0.5*(WithinMeanCorr1+WithinMeanCorr2))/BetweenCorr; % /
end


%%
% FeaǰKpֵ֮СڲPvalParaۼӣ
% PvalMpֵ1*M
% PvalPara׶β
function Fea = CumFea(Pval,PvalPara)
[SortPval, FeaInd] = sort(Pval);
Ind = find(cumsum(SortPval)>PvalPara);
Fea = FeaInd(1:Ind-1);
end
