%% ݼͱԣԶԽԤ⣨ͷ
% Step 3, After MainDataEval.mʶݼͱ֮
% 20210928
% ݼ֡ڽϿɿĵͱ
% Input: ݼĵͱԣһݼ
% Output:
% Ԥ⣺ݼͷԴݵĵͱ
clear
clc
close all

% ·
LoadPath = '../result/TypicalData/'; % load 
SavePath = strcat('../result/Evaluation/IndepTypical/');

LoadDataPath = '../data/Regression/'; % FNC Matrix
DataName = {'FBIRN', 'MPRC', 'BSNIP','COBRE'};

LoadMotPath = 'D:/Data/FNC/'; % Demographic
DemoDataName = {'FBIRN-137SZ_144HC', 'PK-150SZ-238HC', 'BSNIP-182SZ_237HC','COBRE-68SZ_89HC'}; % ˿Ϣͳ

thres = 0.8; % ֵ

%% # Scoring ݼԵķ
IndepScore = cell(length(DataName)+1,2);
IndepScore(1,2) = {'Scores'}; % ÿݼӦN*DķNDӦԴݼ
IndepScore(2:end,1) = DataName;

for IndID = 1:length(DataName) % Ըݼ
    fprintf(strcat('---------------------------------Scoring for',32,DataName{IndID},'---------------------------------'));fprintf('\n');
    ind = find(strcmp(DataName{IndID},IndepScore(:,1)));

    load(strcat(LoadDataPath,DataName{IndID},'.mat')); 
    IndepData = eval(DataName{IndID}); clear FBIRN MPRC BSNIP COBRE
    [SubNum, Col] = size(IndepData);
    IndepLabel = IndepData(:,Col);
    ScoreTemp = zeros(SubNum,length(DataName)+1); %  ֵ
    for MainID = 1:length(DataName) % λݼͱݼ
        if IndID==MainID
            ScoreTemp(:,MainID) = IndepLabel;
            continue
        end

        load(strcat(LoadDataPath,DataName{MainID},'.mat')); 
        load(strcat(LoadPath,DataName{MainID},'.mat'),'count');
        data = eval(DataName{MainID}); clear FBIRN MPRC BSNIP COBRE
        MainData = data(count(:,4)>=thres,:);
        [ScoreTemp(:,MainID)] = ScoreComput(IndepData,MainData);
    end
    idx = any(ScoreTemp(:,1:4)==0,2);
    ScoreTemp(:,5) = mean(ScoreTemp(:,setdiff([1:length(DataName)],IndID)),2);
    ScoreTemp(idx,5) = 0;
    IndepScore{ind,2} = ScoreTemp;
    clear IndepData IndepLabel MainData data count ScoreTemp idx
    save(strcat(SavePath,'IndepScore.mat'),'IndepScore');
end
clear IndepScore


%%
function  [Scores] = ScoreComput(IndepData,MainData)
Col = size(IndepData,2);
IndepAttr = IndepData(:,1:Col-1);
IndepLabel = IndepData(:,Col);

MainAttr = MainData(:,1:Col-1);
MainLabel = MainData(:,Col);
for i = 1:length(unique(MainLabel))
    eval(['MainGroup',num2str(i),'=','MainAttr(MainLabel==i,:)',';']);
end
% ttest2
[~,Pval] = ttest2(MainGroup1,MainGroup2);
Fea = CumFea(Pval,0.01/(Col-1));

MainAttr = [MainGroup1;MainGroup2];


[Center1] = mean(MainGroup1(:,Fea));
[Center2] = mean(MainGroup2(:,Fea));

DisTypicalGroup1 = mean(pdist2(IndepAttr(:,Fea),Center1),2);
DisTypicalGroup2 = mean(pdist2(IndepAttr(:,Fea),Center2),2);


Distance = DisTypicalGroup1+DisTypicalGroup2;
A = DisTypicalGroup1./(Distance);
B = DisTypicalGroup2./(Distance);
Scores = tan((A-B)*pi/2);


end
